Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.codehaus.groovy.grails.web.mapping
[Java] Interface LinkGenerator

    public interface LinkGenerator

Generates links for a Grails application based on URL mapping rules and/or base context settings.

Authors:
  Graeme Rocher

Since:
  2.0

Field Summary
`java.lang.String` | `ATTRIBUTE_ABSOLUTE`
`java.lang.String` | `ATTRIBUTE_ACTION`
`java.lang.String` | `ATTRIBUTE_BASE`
`java.lang.String` | `ATTRIBUTE_CONTEXT_PATH`
`java.lang.String` | `ATTRIBUTE_CONTROLLER`
`java.lang.String` | `ATTRIBUTE_ELEMENT_ID`
`java.lang.String` | `ATTRIBUTE_EVENT`
`java.lang.String` | `ATTRIBUTE_FRAGMENT`
`java.lang.String` | `ATTRIBUTE_ID`
`java.lang.String` | `ATTRIBUTE_MAPPING`
`java.lang.String` | `ATTRIBUTE_PARAMS`
`java.lang.String` | `ATTRIBUTE_URI`
`java.lang.String` | `ATTRIBUTE_URL`
`java.util.Set` | `LINK_ATTRIBUTES`

Method Summary
`java.lang.String` | `getContextPath()` Obtains the context path from which this link generator is operating.
`java.lang.String` | `getServerBaseURL()` The base URL of the server used for creating absolute links.
`java.lang.String` | `link(java.util.Map params)` Generates a link to a controller, action or URI for the given named parameters.
`java.lang.String` | `link(java.util.Map params, java.lang.String encoding)` Generates a link to a controller, action or URI for the given named parameters.
`java.lang.String` | `resource(java.util.Map params)` Generates a link to a static resource for the given named parameters.

Field Detail

### ATTRIBUTE_ABSOLUTE

    public java.lang.String ATTRIBUTE_ABSOLUTE

### ATTRIBUTE_ACTION

    public java.lang.String ATTRIBUTE_ACTION

### ATTRIBUTE_BASE

    public java.lang.String ATTRIBUTE_BASE

### ATTRIBUTE_CONTEXT_PATH

    public java.lang.String ATTRIBUTE_CONTEXT_PATH

### ATTRIBUTE_CONTROLLER

    public java.lang.String ATTRIBUTE_CONTROLLER

### ATTRIBUTE_ELEMENT_ID

    public java.lang.String ATTRIBUTE_ELEMENT_ID

### ATTRIBUTE_EVENT

    public java.lang.String ATTRIBUTE_EVENT

### ATTRIBUTE_FRAGMENT

    public java.lang.String ATTRIBUTE_FRAGMENT

### ATTRIBUTE_ID

    public java.lang.String ATTRIBUTE_ID

### ATTRIBUTE_MAPPING

    public java.lang.String ATTRIBUTE_MAPPING

### ATTRIBUTE_PARAMS

    public java.lang.String ATTRIBUTE_PARAMS

### ATTRIBUTE_URI

    public java.lang.String ATTRIBUTE_URI

### ATTRIBUTE_URL

    public java.lang.String ATTRIBUTE_URL

### LINK_ATTRIBUTES

    public java.util.Set LINK_ATTRIBUTES

Method Detail

### getContextPath

    public java.lang.String getContextPath()

  Obtains the context path from which this link generator is operating.
  Returns:
    The base context path

### getServerBaseURL

    public java.lang.String getServerBaseURL()

  The base URL of the server used for creating absolute links.
  Returns:
    The base URL of the server

### link

    public java.lang.String link(@SuppressWarnings("rawtypes") java.util.Map params)

  Generates a link to a controller, action or URI for the given named parameters. Possible named parameters include:
  - controller - The name of the controller to use in the link, if not specified the current controller will be linked
  - action - The name of the action to use in the link, if not specified the default action will be linked
  - uri - relative URI
  - url - A map containing the action,controller,id etc.
  - base - Sets the prefix to be added to the link target address, typically an absolute server URL. This overrides the behaviour of the absolute property, if both are specified.
  - absolute - If set to "true" will prefix the link target address with the value of the grails.serverURL property from Config, or http://localhost:<port> if no value in Config and not running in production.
  - contextPath - The context path to link to, defaults to the servlet context path
  - id - The id to use in the link
  - fragment - The link fragment (often called anchor tag) to use
  - params - A map containing URL query parameters
  - mapping - The named URL mapping to use to rewrite the link
  - event - Webflow _eventId parameter
  Parameters:
    `params` - The named parameters
  Returns:
    The generator link

### link

    public java.lang.String link(@SuppressWarnings("rawtypes") java.util.Map params, java.lang.String encoding)

  Generates a link to a controller, action or URI for the given named parameters. Possible named parameters include:
  - controller - The name of the controller to use in the link, if not specified the current controller will be linked
  - action - The name of the action to use in the link, if not specified the default action will be linked
  - uri - relative URI
  - url - A map containing the action,controller,id etc.
  - base - Sets the prefix to be added to the link target address, typically an absolute server URL. This overrides the behaviour of the absolute property, if both are specified.
  - absolute - If set to "true" will prefix the link target address with the value of the grails.serverURL property from Config, or http://localhost:<port> if no value in Config and not running in production.
  - id - The id to use in the link
  - fragment - The link fragment (often called anchor tag) to use
  - params - A map containing URL query parameters
  - mapping - The named URL mapping to use to rewrite the link
  - event - Webflow _eventId parameter
  Parameters:
    `params` - The named parameters
    `encoding` - The character encoding to use
  Returns:
    The generator link

### resource

    public java.lang.String resource(@SuppressWarnings("rawtypes") java.util.Map params)

  Generates a link to a static resource for the given named parameters. Possible named parameters include:
  - base - The base path of the URL, typically an absolute server path
  - contextPath - The context path to link to, defaults to the servlet context path
  - dir - The directory to link to
  - file - The file to link to (relative to the directory if specified)
  - plugin - The plugin that provides the resource
  - absolute - Whether the link should be absolute or not
  Parameters:
    `params` - The named parameters
  Returns:
    The link to the static resource

Groovy Documentation